﻿using System;
using Zennolab.CommandCenter;

namespace thirtyboxcode
{
	internal class Step1
	{
		public static int Execute(Instance instance)
		{
			// Clearing cookies
			instance.ClearCookie();

			// Going to http://30boxes.com/
			Tab tb = instance.MainTab;
			if ((tb.IsVoid) || (tb.IsNull)) return -1;
			if (tb.IsBusy) tb.WaitDownloading();
			tb.Navigate("http://30boxes.com/");
			if (tb.IsBusy) tb.WaitDownloading();

			tb = instance.MainTab;
			if ((tb.IsVoid) || (tb.IsNull)) return -1;
			if (tb.IsBusy) tb.WaitDownloading();
			var attribute = tb.URL;

			// Executing macros
			var result = instance.RiseMacros("RegExp.RegExp", new[] { "res:\\/\\/ieframe.dll\\/.*", "0" });

			HtmlElement he;
			// Click the link "Free Sign Up"
			he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByAttribute("a", "href", "http://30boxes.com/signup", "regexp", 0);
			if (he.IsVoid) {
				he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByAttribute("a", "InnerText", "Free\\ Sign\\ Up", "regexp", 0);
			}
			if (he.IsVoid) return -1;

			he.RiseEvent("click", false);
			if (tb.IsBusy) tb.WaitDownloading();
			if (instance.GetTabByAddress("popup").IsBusy) instance.GetTabByAddress("popup").WaitDownloading();

			// Executing macros
			result = instance.RiseMacros("File.GetString", new[] { "\\Resources\\email.txt", "random", "false" });

			// Executing macros
			result = instance.RiseMacros("String.Split", new[] { ":", "0" });

			// Executing macros
			result = instance.RiseMacros("String.Split", new[] { ":", "1" });

			// Email
			he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 0).FindChildByName("email");
			if (he.IsVoid) {
				he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 0).FindChildById("email");
			}
			if (he.IsVoid) {
				he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 0).FindChildByAttribute("input:text", "fulltag", "input:text", "text", 0);
			}
			if (he.IsVoid) return -1;

			he.SetValue(result, true);

			// Password
			he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 0).FindChildByName("password");
			if (he.IsVoid) {
				he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 0).FindChildByAttribute("input:password", "fulltag", "input:password", "text", 0);
			}
			if (he.IsVoid) return -1;

			// Executing macros
			he.SetValue(instance.RiseMacros("FieldData.FieldData", new [] { "●5●4●6●9●9●4●", "≡5≡7≡8≡7≡1≡8≡4≡0≡8≡" }), true);


			// Setting value [{-Person.F...] to the element with tag [input:text]
			he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 0).FindChildByName("first");
			if (he.IsVoid) {
				he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 0).FindChildByAttribute("input:text", "fulltag", "input:text", "text", 1);
			}
			if (he.IsVoid) return -1;

			// Executing macros
			he.SetValue(instance.RiseMacros("Person.FirstName", new [] { "eng", "male" }), true);


			// Setting value [{-Person.L...] to the element with tag [input:text]
			he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 0).FindChildByName("last");
			if (he.IsVoid) {
				he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 0).FindChildByAttribute("input:text", "fulltag", "input:text", "text", 2);
			}
			if (he.IsVoid) return -1;

			// Executing macros
			he.SetValue(instance.RiseMacros("Person.LastName", new [] { "eng", "male" }), true);


			// Setting value [True] to the element with tag [input:checkbox]
			he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 0).FindChildByName("terms");
			if (he.IsVoid) {
				he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 0).FindChildByAttribute("input:checkbox", "fulltag", "input:checkbox", "text", 0);
			}
			if (he.IsVoid) return -1;

			he.SetValue("True", true);

			// Click the button
			he = instance.GetTabByAddress("page").GetDocumentByAddress("0").FindElementByTag("form", 0).FindChildByAttribute("input:image", "fulltag", "input:image", "text", 0);
			if (he.IsVoid) return -1;

			he.RiseEvent("click", false);
			if (tb.IsBusy) tb.WaitDownloading();
			if (instance.GetTabByAddress("popup").IsBusy) instance.GetTabByAddress("popup").WaitDownloading();
			return 0;
		}
	}
}
